/*
 * Copyright (C) 2000,2001  Florian Sander
 *
 * $Id: slang_chanlang.c (1.1.0) for AversE-XP v1.0+ 2003/12/06 [Xp-AvR] Exp $
 */

struct slang_chanlang {
  struct slang_chanlang *next;
  char *chan;
  char *lang;
};

static struct slang_chanlang *chanlangs = NULL;

static struct slang_chanlang *slang_chanlang_add(struct slang_chanlang *, char *, char *);
static int slang_chanlang_expmem(struct slang_chanlang *);
static void slang_chanlang_free(struct slang_chanlang *);
static char *slang_chanlang_get(struct slang_chanlang *, char *);

static struct slang_chanlang *slang_chanlang_add(struct slang_chanlang *where, char *chan, char *lang)
{
  struct slang_chanlang *item;

  for (item = where; item; item = item->next)
    if (!rfc_casecmp(item->chan, chan))
      break;
  if (!item) {
    item = nmalloc(sizeof(struct slang_chanlang));
    item->chan = nmalloc(strlen(chan) + 1);
    strcpy(item->chan, chan);
    item->lang = nmalloc(strlen(lang) + 1);
    strcpy(item->lang, lang);
    item->next = where;
    where = item;
  } else {
    Assert(item->lang);
    item->lang = nrealloc(item->lang, strlen(lang) + 1);
    strcpy(item->lang, lang);
  }
  return where;
}

static int slang_chanlang_expmem(struct slang_chanlang *what)
{
  int size = 0;

  while (what) {
    Assert(what);
    Assert(what->chan);
    Assert(what->lang);
    size += sizeof(struct slang_chanlang);
    size += strlen(what->chan) + 1;
    size += strlen(what->lang) + 1;
    what = what->next;
  }
  return size;
}

static void slang_chanlang_free(struct slang_chanlang *what)
{
  struct slang_chanlang *next;

  while (what) {
    Assert(what);
    Assert(what->chan);
    Assert(what->lang);
    next = what->next;
    nfree(what->chan);
    nfree(what->lang);
    nfree(what);
    what = next;
  }
}

static char *slang_chanlang_get(struct slang_chanlang *where, char *chan)
{
  while (where) {
    if (!rfc_casecmp(where->chan, chan))
      return where->lang;
    where = where->next;
  }
  return default_slang;
}

/* tries to find an appropriate language for nick by searching
 * him on a channel and using the language of this channel. */
static struct slang_header *slang_getbynick(struct slang_header *where, char *nick)
{
  struct chanset_t *chan;

  for (chan = chanset; chan; chan = chan->next)
    if (ismember(chan, nick))
      return slang_find(where, slang_chanlang_get(chanlangs, chan->dname));
  return slang_find(where, default_slang);
}
